### How to organize your individual repo

Directory structure:
```
* [root] individual-work/
  * user_service/       [added week3]
    * api_tests.py
    * function_app.py   [added week6]
    * server.py         [added week5]
    * user_models.py
    * unit_tests.py
    * UserManager.py
  * app/                [added week8]
    * templates/
      * index.html
      * (etc.)
    * app.py
  * README.md
```

Notes:
* your repo evolves throughout the course
  * user_service directory and files are created in week3-pymongo
  * server.py is added week5
  * function_app.py and other files (host.json, requirements.txt) added week6
* contents of README.md, e.g.:
  * notes on what is done / not done
  * commands for running tests, starting servers, deploying, etc.

### How to organize your group repo

Directory structure:
```
* [root] group-project/
  * designs/
    * planning/         [week1]
    * system_designs/   [week2]
    * ui_designs/       [week7]
  * services/           [week4]
    * service1/
    * service2/
    * user_service/
  * testing/
    * [api integration tests]
  * zzz_etc/
    * [any other files]
  * README.md
```

Contents of README.md
```md
## Project overview

* Project name and vision statement.  
* Services / subteams and subteam members.

## Usage

* Directions / commands for: running tests, starting servers, deploying, etc.
* URLs for deployed APIs.
* etc.

## Project information

* Development status - what works, what doesn't, etc.
* Continually updated log of changes / contributions - individuals should be credited with their work here.