## Development overview

### Basic architecture

After Epic 1a:

``` mermaid 
flowchart LR
    apitest[API tests]
    api[user API]
    apitest <--> api

    db[(Database)]
    api <--> db
```

After Epic 1b:

``` mermaid
flowchart LR
    user((user / 
        browser))
    app[App server]
    user <--> app

    api[user API]
    app <--> api

    db[(Database)]
    api <--> db    
```  

### Sub-epics

**Epic 1a: API for user management**

* As an application developer, I want to use an API endpoint to create users, so that I can do API testing and/or develop multiple applications that connect to the API.
* As a dev, I want to user an API endpoint to read users..
* etc..

**Epic 1b: App functionality for user management**

* As an user, I want to use a web UI to create users..
* etc..

### Development tasks (Epic 1a)

Tasks for user API:
1. Data modeling
2. Database management
3. API development

Notes:
* Tasks don't always fit into stories (e.g., data modeling is more of a high-level task.)
* It often makes sense for a developer to take a set of related stories (e.g. all of the user CRUD operations).  
* We will do DB mgmt for all CRUD operations; followed by API development.






