
from pydantic import BaseModel
from pydantic_core._pydantic_core import ValidationError

class User(BaseModel):
    username:str
    password:str

def user_test1():

    data1 = {'username': 'joe',
            'password': 'schmoe',
            'extra_field': 'ignored'}

    user = User(**data1) 
    #print(user)
    assert('extra_field' not in user.model_fields)

    user_dict = user.model_dump()
    #print(user_dict)
    assert('extra_field' not in user_dict)

def user_test2():

    data2 = {'missing_field': 'exception',
             'password': 'schmoe'}
    
    try:
        user = User(**data2) 
        status = 1
    except ValidationError as e:
        status = 0

    assert(status==0)

if __name__=="__main__":
    user_test1()
    user_test2()