---
marp: true
---

# ***Data modeling***

---
# What is data modeling?
* Data modeling is the process of creating a visual representation of either a whole information system or parts of it to communicate connections between data points and structures.

---
# Starting with services
* Identify 1-2 entities per service
```
* User account management
  - user
* Courses and enrollments
  - course
  - section
* Student records
  - transcript
```

---
# Relationships
* Identify entity relationships:
  * one-to-one (user-transcript)
  * one-to-many (course-section)
  * many-to-many (users-sections)

---
# ER diagram

<img src='images\sis-ERD.png' height=50%>

---
# Identifying fields (data model)
* basic fields
```
* user
  - user_id
  - username
  - password
* course
  - dept_code
  - course_num
  - title
* section
  - course_id
  - section_num
```
---
# Identifying fields (data model)
* ctd.
```
* transcript
    - student_id
    - semesters
        - courses
            - grades
```

---
# Modeling relationships
* How you model relationships depends on several factors, e.g.:
  * what DB tech you're using (SQL vs. NoSQL)
  * characteristics of your data
  * access scenarios
  * etc.
* More on this later.

---
# Modeling relationships
* user-transcript
  * in separate services - use references
  * store reference to use in transcript
* course-section
  * course and section are within one service
  * sections can be embedded in courses
* user-section
  * in separate services - use references
  * store reference in section - enrollments are managed by the course service.

---
# Pydantic models

