### Use a generic DB manager

* Handling essential CRUD operations:
    * create 
    * read_by_id; read; read_all
    * update
    * delete_by_id; delete; delete_all
* Parameters and returns:
    * You can use pydantic BaseModel for parameters to create, query, and update.
    * You can just return pymongo documents and cursors.
* code reuse:
    * A generic DB mangager can be reused in multiple services.
    * You can still create a specialized DB manager by inheriting from the generic one.

Examples:
```python
    def create(self, obj:BaseModel):
        '''create user and return _id as str'''

        u = obj.model_dump()
        u['_id']=str(ObjectId())

        x = self.col.insert_one(u)
        return str(x.inserted_id)

    def read(self,query:BaseModel):

        docs = self.col.find(query.model_dump(exclude_none=True))
        return list(docs)
```