## Lab 4 - More data manageent

Each team will develop:
* A GroupManager (or something similar)
* One other entity / relationship.

Submission (group):
* You will enter your work into Gitlab using issues.
* You will add your code to your group repo

### Planning

Dividing up the work:
* Vertical vs horizontal slicing
  * vertical slice - develop one story end-to-end (DB, API, UI)
  * horizontal slice - develop one layer at a time
* Best practice for Agile development is normally to slice vertically
  * But that is assuming the team is experienced.
  * Since we are learning these things one at a time (DB, API, UI), we are going to develop horizontal slices.

Suggested division of labor
* Each subteam develops DB operations for one service.
* Individuals on subteam collaborate on data models and function signatures
* Divide up methods.  Each member is in charge of writing unit tests for the methods they implement.

Example (SIS):
  * Subteam A - Course management
    * members X&Y - Data models and function signatures
    * member X - CRUD operations
    * member Y - Relationship (Course-People)
  * Subteam B - Student records
    * etc...

### Working with Gitlab

Create new Issues for your development tasks.

Setup labels to organize your work:
* Manage > Labels
* create scoped labels, e.g.:
  * entity1::story <- label your user stories like this
  * entity1::API <- label your DB+API tasks like this

Set up Milestones 
* Plan > Milestones > [New Milestone]
* Create one Milestone for each subteam, e.g. "Course management," "Student records"

Set up issue boards
* Plan > Issue boards
* [Create List] > Milestone > select milestone
* You can have two issue boards, or one issue board with both teams' Milestones
* Move the development tasks into the appropriate Milestones / columns.

View progress on Milestones:
* When you complete an item, move it to 'Closed' column in your issue board.
* Then go to: Plan > Milestones > select Milestone
* you should see ongoing and completeed issues for each Milestone