
### Handle exceptions in the server

* a duplicate key will raise an Exception in the DB manager
* we can catch this in the server and return a 409.  

user_server.py:
```python
@app.post('/users/')
async def create(user: User) -> str:

    try:
        uid = um.create(user)
        return uid
    except pymongo.errors.DuplicateKeyError as e:
        raise HTTPException(status_code=409, detail=str(e))
    except Exception as e:
        raise HTTPException(status_code=400, detail=str(e))
```

