### Lab 6 - Deploy and integrate group project services

Directory structure (something like this, names may vary):
* user_service/
* <service1_name>/
  * [files are similar to user_service]
* <service2_name>/
  * [files are similar to user_service]
* integration_tests/
  * relationship1_tests.py

For example,
* user_service/
* course_service/
* integration_tests/
  * course_user_tests.py

course_user_tests:
* test adding / removing users to / from courses
* test viewing users by course 
* test viewing courses by user

### Tasks

Tasks:
* Planning
* Development
    - each subteam, implement and test your API (one API per subteam)
* Deployment
    - each subteam, deploy to Azure functions (one deployment per subteam)
* Integration testing
    - create API integration tests for relationships across services.

Gitlab planning:
* Divide the work among your team / subteams
* Create new issues and add them to the appropriate milestone
* Example issues:
  * API endpoints for CRUD operations
  * API endpoints for relationships
  * deploy API
  * API integration testing

Gitlab repository:
* all designs and code should be stored in the group repo.
* the repo root should have a descriptive README.md.
* each service should have its own subdirectory under the repo root.
* there should be a testing subdirectory with integration tests.