# Overview

Two user stories:
* "As an administrator I want to view a list of all users..."
* "As an administrator I want to create a new user..."

Notice that we will now have 2+ sets of endpoints:
* App endpoints (one set)
* API endpoints (one set per service)

## User story 1: view all users

### Routes

For this user story, they happen to have the same method and route:
* App route: GET /users/
  * returns a user_listing page (HTML)
* API route: GET /users/
  * returns a UserCollection (JSON)

### Sequence diagram

``` mermaid
sequenceDiagram
    Client->>App: GET /users/
    App->>User Service: GET /users/
    User Service->>App: UserCollection
    App->>Client: users.html
```

## User story 2: create new user

### Routes

Now there are a few relevant routes:
* App routes:
  * GET /create_user/
    * returns a HTML page with a form
  * POST /users/
* API routes:
  * POST /users/
    * returns a CreateUserResult (or something similar)

### Sequence diagram

``` mermaid
sequenceDiagram
    Client->>App: GET /create_user/ 
    App->>Client: create_user.html
    Client->>App: POST /users/
    App->>User Service: POST /users/
    User Service->>App: CreateUserResult
    App->>Client: (redirect with message)
```