---
marp: true
---

---
# Blueprints
* use blueprints to organize your routes and templates
* prepare a new file for user routes, user_routes.py
```python
from flask import Blueprint
```
```python
user_routes = Blueprint('user_routes', __name__,
                        template_folder='user_templates')
```

---
# Registering blueprints
* in app.py
```python
from flask import Flask
from user_routes import user_routes

app = Flask(__name__)
app.register_blueprint(user_routes)
```

---
# Blueprints
* Now move the appropriate routes into user_routes
* Be sure to use @user_routes instead of @app
```python
@user_routes.get("/accounts")
def accounts():
    return render_template('accounts.html')
```

---
# Impact on url_for
* You also need to specify the blueprint when you use url_for
* in your routes and in your templates
```python
url_for('user_routes.list_users')
```