---
marp: true
---

# Flask continued

---
# Flask Request
* this is *NOT* the same as python requests
```python
from flask import request
```
```python
@app.route('/create_user/', methods=['GET', 'POST'])
def create_user():

    if request.method == 'GET':
        return render_template('create_user.html')

    # Handle POST here
```

---
# Form to create_user
* goes in templates/create_user.html
* it is essential to specify method="post"
```html
<form method="post">
    username:<input name="username"/><br/>
    password:<input type='password' name="password"/><br/>
    <input type='submit' value="submit">
</form>
```

---
# Getting the form data
* goes in create_user function in app.py, in the "handle POST" section
* redirect appropriately based on success/fail
```python
un = request.form.get('username')
pw = request.form.get('password')

# TODO: Make a call to your user API to create a user

if success:
    return redirect(url_for('list_users'))
else:
    return redirect(url_for('create_user'))
```

---
# Flashing messages
* used to give feedback to the user
``` python
# Add the secret key after this:
# app = Flask(__name__)
app.secret_key = b'_5#y2L"F4Q8z\n\xec]/'
```
```python
if success:
    flash(f'successfully created user {username}')
    return redirect(url_for('list_users'))
else:
    flash(f'failed to create user - {err_msg}')
    return redirect(url_for('create_user'))
```

---
# Showing flashed messages
* use the logic if you only want to show the div when there is a message to show
* this will only show the first flash message
``` html
{% set messages=get_flashed_messages() %}
{% if messages %}
    <div> {{messages[0]}} </div>
{% endif %}
```