---
marp: true
---

# Deleting users

---
# Goal and info
* We want to add a delete button to the user detail page.
* (Without using JS) Your browser will only support GET and POST methods
* POST is more appropriate than GET, since we are making changes

---
# Route for update user
```python
@app.route('/update_user/<uid>', methods=['GET', 'POST'])
def update_user(uid):

    if request.method == 'GET':
        return render_template('update_user.html')

    # Handle POST here
```

---
# Update user page
* Two forms on this page
* One to update password (or another field or fields), another to delete the user
* Both use POST

---
# Forms
* Don't make it too easy to change password or delete user.
* Require the user to enter their password in order to do either of these things.
* Verify in the app server that the password is correct before completing the action.

---
# Form action
* don't need to specify action on update_user - we will use POST method on the same route
* DO need to specify action on delete_user
```html
<form method="POST" action="{{ url_for('user_routes.delete_user',_id=user._id)}}">
```

---
# Handling POST to update_user
```python
    # continues update_user from above

    # TODO: get the data from the form
    # TODO: verify password
    # TODO: make an update request to your user API
    # TODO: flash appropriate message

    return redirect(url_for('user_routes.list_users'))
```

---
# Handling POST to delete_user
```python
@user_routes.post('/delete_user/<_id>')
def delete_user(_id):

    # TODO: get the data from the form
    # TODO: verify password
    # TODO: make a delete request to your user API
    # TODO: flash appropriate message

    return redirect(url_for('user_routes.list_users'))
```

