---
marp: true
---

# Azure deployment options

---
# Azure deployment options
* There are any ways to deploy apps in azure.
* Deploying a monolith:
    * This is the easiest option - deploy monolith with Azure App Service.
* Microservices
    * Microservices deployed in containers - ACA or AKS
    * Microservices with functions - Azure functions

---
# Deploying a monolith
* Monolith is a really simple application structure
* e.g., your flask app connects directly to your DB cluster.
* You can deploy with Azure app services using code or containers.

---
# Deploying microservices
* Recall benefits (next slide)
* But adds complexity (as you've discovered)

---
# Recall: benefits of microservies
* Improved scalability: Each service can be scaled independently.
* Enhanced fault isolation: Issues in one service do not affect others.
* Faster development and deployment: Teams can work on services independently.
* Technology flexibility: Different services can use different technologies or programming languages.
* Easier maintenance: Smaller, focused codebases are easier to manage.

---
# Microservices with containers - Docker Compose
* Docker Compose is a tool for defining and running multi-container Docker applications.
* With a single command, you can create and start all the services defined in the configuration.
* Ideal for managing multi-container applications in development and testing environments.

---
# Deploying containerized apps
* A single containerized app can be deployed with AAS or ACA
* Azure Container Apps (ACA) enables you to build serverless microservices and jobs based on containers.
* Features
    * Optimized to run general purpose containers, especially for applications that span many microservices deployed in containers.

---
# What is Kubernetes?
* Kubernetes (often shortened to "k8s") is an open-source container orchestration platform that automates the deployment, scaling, and management of containerized applications.
* Together:
    * Docker Compose can define and test your application locally.
    * Kubernetes can deploy and manage your application at scale in production environments.

---
# Azure Kubernetes Service
* Azure Kubernetes Service (AKS) provides a fully managed Kubernetes option in Azure. 
It supports direct access to the Kubernetes API and runs any Kubernetes workload.

---
# Azure Functions
* Azure Functions is a serverless Functions-as-a-Service (FaaS) solution.

---
# Combined solution
* host app with AAS or ACA
* host microservices with Azure functions
  - our microservices are mostly event-driven - db operations
  - for longer running services, containerized microservices would be better

---
# Price comparison
* https://azure.microsoft.com/en-us/pricing/calculator/ 

---
# Note on latency
* Azure functions: 
    * Cold Start: High latency (~1–10 sec) when using Consumption Plan, as instances must spin up.
    * Premium Plan: Reduces cold start latency by keeping instances warm.
* Azure app service:
    * Free tier (F1).  Cold Start: Can be slow since the app sleeps after 60 minutes of inactivity.
    * generally low latency on paid tiers.  
    * B1 tier is ~$50-60/mo.  
* Azure container apps:
    * Cold Start: Lower than Azure Functions but higher than App Service on B1.
    * The first 2 million requests each month are free.


